class BinaryTree:

    def __init__(self, newValue):
        self.key = newValue
        self.left = None
        self.right = None

    def getLeft(self):
        return self.left

    def getRight(self):
        return self.right

    def setRoot(self, newValue):
        self.key = newValue

    def getRoot(self):
        return self.key


class Queue:

    def __init__(self):
        self.items = []

    def push(self, item):
        self.items.append(item)

    def pop(self):
        return self.items.pop(0)

    def isEmpty(self):
        return self.items == []

    def getFront(self):
        return self.items[0]

    def getSize(self):
        return len(self.items)


def layerOrder(T):
    leaf = []

    q = Queue()
    q.push(T)

    while not q.isEmpty():
        p = q.pop()
        if not p.left and not p.right:
            leaf.append(str(p.key))
        if p.left:
            q.push(p.left)
        if p.right:
            q.push(p.right)
    return leaf


def buildTree(T, lt, rt):
    if T:
        k = T.key
        if lt[k] != '-':
            T.left = BinaryTree(int(lt[k]))
            buildTree(T.left, lt, rt)
        if rt[k] != '-':
            T.right = BinaryTree(int(rt[k]))
            buildTree(T.right, lt, rt)


r = -1
lt = []
rt = []

n = int(input())
for i in range(n):
    l, r = input().split()
    lt.append(l)
    rt.append(r)
for i in range(n):
    if str(i) not in lt and str(i) not in rt:
        r = i
        break
T = BinaryTree(r)
buildTree(T, lt, rt)
res = layerOrder(T)
print(" ".join(res))